/****************************
CrushFTP GUI Plugin custom js
*****************************/
/* Do not change these lines */
var pluginWebApplication = {};
pluginWebApplication.localization = {};
/****************************/

// Plugin details
var pluginName = "WebApplication";
var _plugin = $("#pnlPlugin" + pluginName);

// Localizations
pluginWebApplication.localization = {
	lblEnabledText : "Enabled",
	lblDebugText : "Debug",
	lblVersionText : "Version : ",
	lblAllowedServerPortText : "Allowed Server Port : ",
	lblHTTPUsernameText : "HTTP Username : ",
	lblHTTPPasswordText : "HTTP Password : ",
	lblUserXMLURLText : "User XML URL : ",
	lblPostDataText : "Post Data : ",
	lblPermissionXMLURLText : "Permission XML URL : ",
	lblVFSXMLURLText : "VFS XML URL : ",
	lblHTTPMethodText : "HTTP Method : ",
	lblImportSettingsFromUserText : "Import settings from CrushFTP user : ",
	lblOverwriteVFSItemsText : "Overwrite VFS items?"
};

// Assign localizations
localizations.panels["Plugins"][pluginName] = $.extend(pluginWebApplication.localization, localizations.panels["Plugins"][pluginName]);

// Interface methods
pluginWebApplication.init = function(pluginID, returnXML){
	pluginWebApplication.returnXML = returnXML;
	applyLocalizations(pluginName, localizations.panels["Plugins"]);
	pluginWebApplication.bindData(0, pluginID);
}

pluginWebApplication.bindData = function(index, pluginID)
{
	index = index || 0;
	var pluginPrefs = [];
	pluginWebApplication.showServerList();
	if(pluginID)
	{
		var data = $(document).data("PluginBindData" + pluginID);
		pluginPrefs = data.dataItem;
		$(".nonEmbed", _plugin).hide();
	}
	else
	{
		pluginPrefs = common.data.getPluginPrefs(pluginName);
	}
	if(pluginPrefs)
	{
		var curPlugin = pluginPrefs;
		if(!pluginID && pluginPrefs.length)
		{
			curPlugin = pluginPrefs[index];
		}
		pluginWebApplication.bindPluginDetails(curPlugin);
	}
	pluginWebApplication.bindEvents();
}

pluginWebApplication.bindEvents = function()
{
	if(this.eventAdded)return;
	_plugin.find("input, select, textarea").bind("change", function(){
		panelPlugins.itemsChanged(true, pluginWebApplication.returnXML, pluginName);
	});

	_plugin.find("input[type='text'], textarea").bind("textchange", function(){
		panelPlugins.itemsChanged(true, pluginWebApplication.returnXML, pluginName);
	});
	this.eventAdded = true;
}

pluginWebApplication.bindPluginDetails = function(controlData)
{
	var inputs = _plugin.find("input.ignoreBind,select.ignoreBind,textarea.ignoreBind").removeClass("ignoreBind");
	bindValuesFromXML(_plugin, controlData);
	if(controlData.subItem && controlData.subItem.length>0)
		_plugin.attr("subPluginName", controlData.subItem[0].text || false);
	inputs.addClass("ignoreBind");	
}

pluginWebApplication.showServerList = function()
{
	if(!this.serverListShown)
	{
		var service = common;
		if(pluginWebApplication.returnXML)
		{
			service = userManager;
		}
		var serverList = service.data.getSubValueFromPrefs("server_list");		
		var serverPorts = $("#server_item", _plugin);
		for(var i=0;i<serverList.length;i++)
		{
			var curItem = serverList[i];
			if(curItem)
			{
				var serverType = service.data.getTextContentFromPrefs(curItem, "serverType");
				var ip = service.data.getTextContentFromPrefs(curItem, "ip");
				var port = service.data.getTextContentFromPrefs(curItem, "port");
				var server = ip + "_" + port;
				var newControl = $("<option>"+server+"</option>");
				serverPorts.append(newControl);
				newControl.data("controlData", curItem);
			}
		}
		serverPorts.prepend("<option>All</option>");
		this.serverListShown = true;
	}
}

pluginWebApplication.saveContent = function(saveByIndex, cloneName, removeByIndex, callback)
{
	removeByIndex = removeByIndex || 0;
	if(pluginPlaceHolder.data("hasChanged") || removeByIndex>0 || (saveByIndex>0 && cloneName) || pluginWebApplication.returnXML)
	{
		if(!pluginWebApplication.returnXML)
			common.UI.showIndicator(false, false, "Please wait..");

		var xmlString = [];
		var container = _plugin;
		if(removeByIndex == 0)
		{
			xmlString.push("<plugins_subitem type=\"properties\">");
			xmlString.push("<version>"+$("#version", _plugin).text()+"</version>");
			xmlString.push("<pluginName>"+pluginName+"</pluginName>");
			xmlString.push(buildXMLToSubmitForm(_plugin, true));
			if(saveByIndex)
			{
				xmlString.push("<subItem>"+common.methods.htmlEncode(cloneName)+"</subItem>");
			}
			else
			{
				if(container.attr("subPluginName") && this.subItem>0)
				{
					xmlString.push("<subItem>"+common.methods.htmlEncode(container.attr("subPluginName"))+"</subItem>");
				}
				else
				{
					xmlString.push("<subItem></subItem>");
				}
			}
			xmlString.push("</plugins_subitem>");
		}
		var formSubItem = xmlString.join("\n");

		if(pluginWebApplication.returnXML)
			return formSubItem;

		var action = removeByIndex == 0 ? "change" : "remove";
		var index = window.currentPluginIndex;
		var subItemIndex = removeByIndex == 0 ? saveByIndex || this.subItem : removeByIndex;
		subItemIndex = subItemIndex || 0;
		var removeChangeFlag = (saveByIndex>0 && cloneName);
		panelPlugins.savePluginContentProcess(action, formSubItem, index, subItemIndex, removeChangeFlag, callback);
	}
	else
	{
		growl("No changes made", "", false, 3000);
	}
}