/****************************
CrushFTP GUI Panel custom js
*****************************/
/* Do not change these lines */
var panelPreview = {};
panelPreview.localization = {};
/****************************/

// Panel details
var panelName = "Preview";
var _panel = $("#pnl" + panelName);

// Localizations
panelPreview.localization = {
	headerText : " ",
	lblEnabledText : "Enabled",
	lblDebugText : "Debug",
	lblGeneralTabText : "General",
	lblSizesTabText : "Sizes",
	lblConversionUtilityText : "Conversion utility presets : ",
	lblCautionText : "Caution : Changing these fields needs extreme caution as invalid arguments could result in data loss.",
	lblSupportedFileExtensionsText : "Supported file extensions : ",
	lblCommandLineText : "Command Line : ",
	lblWorkingDirectoryText : "Working Directory : ",
	btnFolderLocationBrowseText : "Browse",
	lblEnvironmentVariablesText : "Environment Variables : ",
	lblFramesText : "Frames  : ",
	lblInfoCommandLineText : "Info command line : ",
	lblTimeoutText : "Timeout : ",
	lblScanSubDirText : "Scan subdirectories of directories in below list",
	lblDeleteThumbnailsForNonExistingFilesText : "Delete thumbnails for files that no longer exist.",
	lblScanIntervalInMinutesText : "Scan interval in minutes : ",
	lblThreadsText : "Threads :",
	lblMakeExifText : " Make exif files? (ImageMagick)",
	btnAddFolderText : "Add Folder",
	btnEditFolderText : "Edit Path",
	btnRemoveFolderText : "Remove Folder",
	btnAddText : "Add",
	btnRemoveText : "Remove",
	lblMaxWidthText : "Max Width : ",
	lblMaxHeightText : "Max Height : ",
	btnResetText : "Reset All Prefs to Default",
	btnCancelText : "Cancel",
	btnOKText : "Ok"
};

panelPreview.defaultConfig = {
	preview_command_line: [{text:""}],
	preview_conversion_threads: [{text:"1"}],
	preview_debug: [{text:"true"}],
	preview_enabled: [{text:"false"}],
	preview_environment: [{text:""}],
	preview_exif: [{text:"false"}],
	preview_file_extensions: [{text:""}],
	preview_folder_list: [{preview_folder_list_subitem:[]}],
	preview_frames: [{text:""}],
	preview_movie_info_command_line: [{text:""}],
	preview_reverseSubdirectories: [{text:""}],
	preview_scan_interval: [{text:"1"}],
	preview_sizes: [{preview_sizes_subitem:[{text:"80x80"},{text:"160x160"},{text:"800x800"}]}],
	preview_subdirectories: [{text:"true"}],
	preview_wait_timeout: [{text:"600"}],
	preview_working_dir: [{text:""}]
};

// Assign localizations
localizations.panels[panelName] = $.extend(panelPreview.localization, localizations.panels[panelName]);

// Interface methods
panelPreview.init = function(){
	applyLocalizations(panelName, localizations.panels);
	setPageTitle(panelPreview.localization.Header, true);
	panelPreview.initLayout();
	panelPreview.bindData();
	panelPreview.bindEvents();
}

panelPreview.initLayout = function()
{
	var prefs = $.extend(true, {},$(document).data("GUIXMLPrefs"));
	var previewConfigs = prefs.preview_configs;
	panelPreview.configs = false;
	var totalSubItems = 0;
	if(previewConfigs && previewConfigs.length>0)
	{
		var subConfigs = previewConfigs[0];
		if(subConfigs && subConfigs.preview_configs_subitem)
		{
			subConfigs = subConfigs.preview_configs_subitem;
		}
		if(subConfigs && subConfigs.length>0)
		{
			panelPreview.configs = subConfigs;
		}
	}
	panelPreview.refreshTabs();
	_panel.data("totalPreviewConfigs", totalSubItems);

	var conversionPresets = $("#drpConversionUtility", _panel);
	var machineInfo = $(document).data("server_info") || {};
	if (machineInfo.machine_is_x_10_5_plus == "true")
	{
		conversionPresets.append("<option value=\"pcastaction\">OS X Movies - pcastaction</option>");
		conversionPresets.append("<option value=\"qlmanage\">OS X Everything - qlmanage</option>");
		conversionPresets.append("<option value=\"sips\">OS X Images - sips</option>");
	}
	else if (machineInfo.machine_is_x == "true")
	{
		conversionPresets.append("<option value=\"sips\">OS X Images - sips</option>");
	}
	conversionPresets.append("<option value=\"ImageMagick\">Any OS Images - ImageMagick (must be installed separately)</option>");
	conversionPresets.append("<option value=\"FFmpeg\">Any OS Movies - FFmpeg (must be installed separately)</option>");
}

panelPreview.refreshTabs =function(configs, bindData)
{
	configs = configs || panelPreview.configs;
	var tabAnchors = false;
	var configsAvailable = configs && configs.length>0;
	var configPanel = $("#configTable", _panel);
	var removeConfigBtn = $("#removeConfig", _panel);
	if(configsAvailable)
	{
		totalSubItems = configs.length;
		configPanel.find("div#configSetup").show();
		if($("div.previewSettingsContainer",_panel).length==0)
		{
			configPanel.wrap("<div class=\"ui-widget-content previewSettingsContainer\"></div>");
			configPanel.before("<div class='subConfigTabHandler ui-corner-all ui-widget-header'></div>");
		}
		tabAnchors = configPanel.prev().empty();
		for(var index=0; index<configs.length;index++)
		{
			var curConfig = configs[index];
			var container = configPanel;
			if(configsAvailable)
			{
				var tabName = index + 1;
				tabAnchors.append("<button pluginIndex=\""+index+"\">"+tabName+"</button>");
			}
		}
		tabAnchors.find("button").button().click(function(){
			var btn = $(this);
			if(btn.find(".ui-state-active").length>0)return false;
			panelPreview.bindData(btn.attr("pluginIndex"));
			tabAnchors.find(".ui-state-active").removeClass("ui-state-active");
			btn.find("span").addClass("ui-state-active");
			btn.blur();
		});
		if(panelPreview.currentConfigIndex && panelPreview.currentConfigIndex>0)
		{
			var index = parseInt(panelPreview.currentConfigIndex) + 1;
			tabAnchors.find("button:nth-child("+index+")").addClass("ui-state-active");
		}
		else
		{
			tabAnchors.find("button:first").addClass("ui-state-active");
		}
		if(bindData)
		{
			panelPreview.bindData(panelPreview.currentConfigIndex);
		}
		if(totalSubItems>1)
		{
			tabAnchors.show();
			removeConfigBtn.show();
		}
		else
		{
			tabAnchors.hide();
			removeConfigBtn.hide();
		}
	}
	else
	{
		configPanel.find("div#configSetup").hide();
	}
}

panelPreview.bindData = function(index)
{
	var subConfigs = panelPreview.configs;
	if(subConfigs && subConfigs.length>0)
	{
		index = index || 0;
		panelPreview.currentConfigIndex = index;
		var prefs = subConfigs[index];
		bindValuesFromXML(_panel, prefs);
		var nameList = $("#preview_folder_list", _panel).empty();
		if(prefs["preview_folder_list"])
		{
			var preview_folder_list = prefs["preview_folder_list"];
			if(preview_folder_list.length>0)
			{
				preview_folder_list = preview_folder_list[0]["preview_folder_list_subitem"];
				if(preview_folder_list)
				{
					for(var i=0;i<preview_folder_list.length;i++)
					{
						var curItem = preview_folder_list[i];
						if(curItem && curItem.text)
						{
							var name = curItem.text;
							var newControl = $("<li class='ui-widget-content'>"+unescape(name)+"</li>");
							nameList.append(newControl);
							newControl.data("controlData", curItem);
						}
					}
				}
			}
		}

		var sizeList = $("#preview_sizes", _panel).empty();
		if(prefs["preview_sizes"])
		{
			var preview_sizes = prefs["preview_sizes"];
			if(preview_sizes.length>0)
			{
				preview_sizes = preview_sizes[0]["preview_sizes_subitem"];
				for(var i=0;i<preview_sizes.length;i++)
				{
					var curItem = preview_sizes[i];
					if(curItem && curItem.text)
					{
						var name = curItem.text;
						var newControl = $("<li class='ui-widget-content'>"+unescape(name)+"</li>");
						sizeList.append(newControl);
						newControl.data("controlData", curItem);
					}
				}
			}
		}
	}
}

panelPreview.bindEvents = function()
{
	var preview_folder_list = $("#preview_folder_list", _panel);
	preview_folder_list.selectable({
		selected: function(event, ui) {
			var selected = $(ui.selected);
			selected.parent().find(".ui-widget-header").removeClass("ui-widget-header");
			selected.addClass("ui-widget-header");
			return false;
		}
	});

	var preview_sizes_list = $("#preview_sizes", _panel);
	preview_sizes_list.selectable({
		selected: function(event, ui) {
			var selected = $(ui.selected);
			selected.parent().find(".ui-widget-header").removeClass("ui-widget-header");
			selected.addClass("ui-widget-header");
			panelPreview.bindSizeDetails(selected);
			return false;
		}
	});

	$("a#addConfig", _panel).click(function(evt, control){
		if(!panelPreview.configs)
		{
			panelPreview.configs = [];
		}
		panelPreview.configs.push(panelPreview.defaultConfig);
		panelPreview.refreshTabs(panelPreview.configs, true);
		itemsChanged(true);
		return false;
	});

	$("a#removeConfig", _panel).click(function(evt, control){
		if(panelPreview.configs)
		{
			jConfirm("Are you sure you wish to remove this config?", "Confirm", function(value){
				if(value)
				{
					panelPreview.configs.remove(parseInt(panelPreview.currentConfigIndex));
					if(panelPreview.currentConfigIndex>0)
						panelPreview.currentConfigIndex= parseInt(panelPreview.currentConfigIndex) - 1;
					panelPreview.refreshTabs(panelPreview.configs, true);
					itemsChanged(true);
				}
			});
		}
		return false;
	});

	$("a#addFolder", _panel).click(function(evt, control){
		var labelName =  "";
		if(control)
		{
			labelName = control.text;
		}
		var curElem = $(this);
		var note = false;
		if(labelName.length>0)
		{
			note = "Current selected directory : " + labelName;
		}
		curElem.crushFtpVFSBrowserPopup({
			type : curElem.attr("PickType") || 'dir',
			note : note,
			callback : function(selectedPath){
				if(control)
				{
					preview_folder_list.find("li.ui-selected").text(selectedPath).data("controlData", {
							"text":selectedPath
						});
				}
				else
				{
					common.UI.addItem($("#preview_folder_list", _panel)
						, $("<li class='ui-widget-content'>"+selectedPath+"</li>")
						,{
							"text":selectedPath
						}
					);
					var subConfigs = panelPreview.configs;
					if(subConfigs && subConfigs.length>panelPreview.currentConfigIndex)
					{
						var curItem = subConfigs[panelPreview.currentConfigIndex];
						if(!curItem.preview_folder_list || curItem.preview_folder_list[0] == "")
						{
							curItem.preview_folder_list = [{
								preview_folder_list_subitem : []
							}];
						}
						if(!curItem.preview_folder_list[0].preview_folder_list_subitem)
						{
							curItem.preview_folder_list[0].preview_folder_list_subitem = [];
						}
						var folderList = curItem.preview_folder_list[0].preview_folder_list_subitem;
						folderList.push({
							"text":selectedPath
						});
					}
				}
				itemsChanged(true);
			}
		});
		return false;
	});

	$("a#editFolder", _panel).click(function(){
		if(preview_folder_list.find("li.ui-selected").length>0)
		{
			var selected = preview_folder_list.find("li.ui-selected");
			var controlData = selected.data("controlData");
			if(controlData)
			{
				var labelName = controlData.text;
				jPrompt("Enter folder name: ", labelName, "Enter path", function(_val){
					if(_val && _val.length>0)
					{
						if(controlData)
						{
							selected.text(_val).data("controlData", {
									"text":_val
								});

							var subConfigs = panelPreview.configs;
							if(subConfigs && subConfigs.length>panelPreview.currentConfigIndex)
							{
								var curItem = subConfigs[panelPreview.currentConfigIndex];
								if(!curItem.preview_folder_list)
								{
									curItem.preview_folder_list = [{
										preview_folder_list_subitem : []
									}];
								}
								else if(!curItem.preview_folder_list[0].preview_folder_list_subitem)
								{
									curItem.preview_folder_list[0].preview_folder_list_subitem = [];
								}
								var folderList = curItem.preview_folder_list[0].preview_folder_list_subitem;
								if(folderList)
								{
									for(var i=0;i<folderList.length;i++)
									{
										var curItem = folderList[i];
										if(curItem && curItem.text && curItem.text == labelName)
										{
											curItem.text = _val;
										}
									}
								}
							}
							itemsChanged(true);
						}
					}
				});
			}
		}
		return false;
	});

	$("a#removeFolder", _panel).click(function(){
		var selected = preview_folder_list.find("li.ui-selected");
		var controlData = selected.data("controlData");
		if(controlData)
		{
			var labelName = controlData.text;
			common.UI.removeItem($("#preview_folder_list", _panel), function(){
				var subConfigs = panelPreview.configs;
				if(subConfigs && subConfigs.length>panelPreview.currentConfigIndex)
				{
					var curItem = subConfigs[panelPreview.currentConfigIndex];
					if(!curItem.preview_folder_list)
					{
						curItem.preview_folder_list = [{
							preview_folder_list_subitem : []
						}];
					}
					else if(!curItem.preview_folder_list[0].preview_folder_list_subitem)
					{
						curItem.preview_folder_list[0].preview_folder_list_subitem = [];
					}
					var folderList = curItem.preview_folder_list[0].preview_folder_list_subitem;
					if(folderList)
					{
						var newList = [];
						for(var i=0;i<folderList.length;i++)
						{
							var curItem = folderList[i];
							if(curItem && curItem.text && curItem.text != labelName)
							{
								newList.push(curItem);
							}
						}
						folderList = newList;
						subConfigs[panelPreview.currentConfigIndex].preview_folder_list[0].preview_folder_list_subitem = newList;
					}
				}
				itemsChanged(true);
			});
		}
		return false;
	});

	$("a#addSize", _panel).click(function(){
		common.UI.addItem(preview_sizes_list
			, $("<li class='ui-widget-content'>200x200</li>")
			,{
				"text":"200x200"
			});
		var subConfigs = panelPreview.configs;
		if(subConfigs && subConfigs.length>panelPreview.currentConfigIndex)
		{
			var curItem = subConfigs[panelPreview.currentConfigIndex];
			if(!curItem.preview_sizes)
			{
				curItem.preview_sizes = [{
					preview_sizes_subitem : []
				}];
			}
			else if(!curItem.preview_sizes[0].preview_sizes_subitem)
			{
				curItem.preview_sizes[0].preview_sizes_subitem = [];
			}
			var sizeList = curItem.preview_sizes[0].preview_sizes_subitem;
			sizeList.push({
				"text":"200x200"
			});
		}
		panelPreview.bindSizeDetails(preview_sizes_list.find(".ui-selected"));
		itemsChanged(true);
		return false;
	});

	$("a#removeSize", _panel).click(function(){
		var selected = preview_sizes_list.find("li.ui-selected");
		var controlData = selected.data("controlData");
		if(controlData)
		{
			var labelName = controlData.text;
			common.UI.removeItem(preview_sizes_list, function(){
				var subConfigs = panelPreview.configs;
				if(subConfigs && subConfigs.length>panelPreview.currentConfigIndex)
				{
					var curItem = subConfigs[panelPreview.currentConfigIndex];
					if(!curItem.preview_sizes)
					{
						curItem.preview_sizes = [{
							preview_sizes_subitem : []
						}];
					}
					else if(!curItem.preview_sizes[0].preview_sizes_subitem)
					{
						curItem.preview_sizes[0].preview_sizes_subitem = [];
					}
					var sizeList = curItem.preview_sizes[0].preview_sizes_subitem;
					if(sizeList)
					{
						var newList = [];
						for(var i=0;i<sizeList.length;i++)
						{
							var curItem = sizeList[i];
							if(curItem && curItem.text && curItem.text != labelName)
							{
								newList.push(curItem);
							}
						}
						sizeList = newList;
						subConfigs[panelPreview.currentConfigIndex].preview_sizes[0].preview_sizes_subitem = newList;
					}
				}
				itemsChanged(true);
			});
		}
		return false;
	});

	var previewSizesPanel = $("#PreviewSizes", _panel);
	previewSizesPanel.find("input").bind("textchange", function(){
		var item = preview_sizes_list.find("li.ui-selected");
		if(!item || item.length==0)return;
		var controlData = item.data("controlData");
		if(controlData)
		{
			var labelName = controlData.text;
			var val = $("#preview_max_width", previewSizesPanel).val() + "x" + $("#preview_max_height", previewSizesPanel).val();
			controlData = {text: val};
			item.text(val);
			var subConfigs = panelPreview.configs;
			if(subConfigs && subConfigs.length>panelPreview.currentConfigIndex)
			{
				var curItem = subConfigs[panelPreview.currentConfigIndex];
				if(!curItem.preview_sizes)
				{
					curItem.preview_sizes = [{
						preview_sizes_subitem : []
					}];
				}
				else if(!curItem.preview_sizes[0].preview_sizes_subitem)
				{
					curItem.preview_sizes[0].preview_sizes_subitem = [];
				}
				var folderList = curItem.preview_sizes[0].preview_sizes_subitem;
				if(folderList)
				{
					for(var i=0;i<folderList.length;i++)
					{
						var curItem = folderList[i];
						if(curItem && curItem.text && curItem.text == labelName)
						{
							curItem.text = val;
						}
					}
				}
			}
		}
		item.data("controlData", controlData);
		itemsChanged(true);
	});

	$("#preview_conversion_threads", _panel).blur(function(){
		if($.trim($(this).val()) == "")
		{
			$(this).val(1).trigger("textchange");
		}
	});

	$("a.serverFilePickButton", _panel).each(function(){
		$(this).click(function(){
			var curElem = $(this);
			curElem.crushFtpVFSBrowserPopup({
				type : curElem.attr("PickType") || 'dir',
				callback : function(selectedPath){
					$("#" + curElem.attr("rel"), _panel).val(selectedPath).trigger("textchange");
				}
			});
			return false;
		});
	});

	function updateStorageValue(key, val)
	{
		var subConfigs = panelPreview.configs;
		if(subConfigs && subConfigs.length>panelPreview.currentConfigIndex)
		{
			var curItem = subConfigs[panelPreview.currentConfigIndex];
			curItem[key] = [{text : val}];
		}
	}

	$("#drpConversionUtility", _panel).bind("change", function(){
		var val = $(this).val();
		var configSetup = $("#configSetup", _panel);
		var machineInfo = $(document).data("server_info") || {};
		if(val == "pcastaction")
		{
			$("#preview_conversion_threads", configSetup).val("1").trigger("textchange");
			$("#preview_working_dir", configSetup).val("./").trigger("textchange");
			$("#preview_environment", configSetup).val("PATH=/opt/local/bin:/opt/local/sbin:/opt/local/bin:/opt/local/sbin:/usr/bin:/bin:/usr/sbin:/sbin:/usr/local/bin:/usr/local/git/bin:/usr/X11/bin").trigger("textchange");
			$("#preview_command_line", configSetup).val("./pcastaction_wrapper.sh %previews% %previews%temp/%random%/ %src% %dst% %time% %width%").trigger("textchange");
			$("#preview_file_extensions", configSetup).val(".m4v, .mp4, .mpeg, .mov, .avi, .h264").trigger("textchange");
			$("#preview_frames", configSetup).val("20").trigger("textchange");
			$("#preview_movie_info_command_line", configSetup).val("pcastaction qtinfo --key=duration --prb=%previews% --input=%src%").trigger("textchange");
		}
		else if(val == "qlmanage")
		{
			$("#preview_conversion_threads", configSetup).val("1").trigger("textchange");
			$("#preview_working_dir", configSetup).val("./").trigger("textchange");
			$("#preview_environment", configSetup).val("PATH=/opt/local/bin:/opt/local/sbin:/opt/local/bin:/opt/local/sbin:/usr/bin:/bin:/usr/sbin:/sbin:/usr/local/bin:/usr/local/git/bin:/usr/X11/bin").trigger("textchange");
			$("#preview_command_line", configSetup).val("./qlmanage_wrapper.sh %width% %previews%temp/%random%/ %src% %dst%").trigger("textchange");
			$("#preview_file_extensions", configSetup).val(".jpg, .jpeg, .gif, .png, .bmp, .pdf, .psd, .tif, .tiff, .zip, *.txt, *.rtf, *.doc, *.docx, *.xls, *.xlsx, *.pdf, *.eps, *.ai, *.bmp, *.ppt").trigger("textchange");
			$("#preview_frames", configSetup).val("1").trigger("textchange");
			$("#preview_movie_info_command_line", configSetup).val("").trigger("textchange");
		}
		else if(val == "sips")
		{
			$("#preview_conversion_threads", configSetup).val("").trigger("textchange");
			$("#preview_working_dir", configSetup).val("").trigger("textchange");
			$("#preview_environment", configSetup).val("").trigger("textchange");
			$("#preview_command_line", configSetup).val("sips -Z %width% -s format jpeg %src% -m /System/Library/ColorSync/Profiles/Generic\\ RGB\\ Profile.icc --out %dst%").trigger("textchange");
			$("#preview_file_extensions", configSetup).val(".jpg, .jpeg, .gif, .png, .bmp, .pdf, .psd, .tif, .tiff, .zip").trigger("textchange");
			$("#preview_frames", configSetup).val("1").trigger("textchange");
			$("#preview_movie_info_command_line", configSetup).val("").trigger("textchange");
		}
		else if(val == "ImageMagick")
		{
			if (machineInfo.machine_is_windows == "true")
			{
				$("#preview_conversion_threads", configSetup).val("").trigger("textchange");
				$("#preview_working_dir", configSetup).val("C:\\Program Files\\ImageMagick-6.5.0-Q16\\").trigger("textchange");
				$("#preview_environment", configSetup).val("MAGICK_HOME=./;DYLD_LIBRARY_PATH=./lib").trigger("textchange");
				$("#preview_command_line", configSetup).val("convert.exe -colorspace RGB -strip -geometry %width%x%width% -quality 75 %src%[0] %dst%").trigger("textchange");
				$("#preview_frames", configSetup).val("1").trigger("textchange");
				$("#preview_movie_info_command_line", configSetup).val("").trigger("textchange");
			}
			else
			{
				$("#preview_conversion_threads", configSetup).val("").trigger("textchange");
				$("#preview_working_dir", configSetup).val("/opt/local/bin/").trigger("textchange");
				$("#preview_environment", configSetup).val("PATH=/opt/local/bin:/opt/local/sbin:/opt/local/bin:/opt/local/sbin:/usr/bin:/bin:/usr/sbin:/sbin:/usr/local/bin:/usr/local/git/bin:/usr/X11/bin").trigger("textchange");
				$("#preview_command_line", configSetup).val("./convert -colorspace RGB -strip -geometry %width%x%width% -quality 75 %src%[0] %dst%").trigger("textchange");
				$("#preview_frames", configSetup).val("1").trigger("textchange");
				$("#preview_movie_info_command_line", configSetup).val("").trigger("textchange");
			}
			$("#preview_file_extensions", configSetup).val(".jpg, .jpeg, .gif, .png, .bmp, .ai, .pdf, .psd, .tif, .tiff, .cr2, .dng, .crw, .dcr, .mrw, .nef, .orf, .pef, .srf, .eps").trigger("textchange");
		}
		else if(val == "FFmpeg")
		{
			if (machineInfo.machine_is_windows == "true")
			{
				$("#preview_conversion_threads", configSetup).val("1").trigger("textchange");
				$("#preview_working_dir", configSetup).val("C:\\Program Files\\FFMpeg\\").trigger("textchange");
				$("#preview_environment", configSetup).val("").trigger("textchange");
				$("#preview_command_line", configSetup).val("ffmpeg.exe -i %src% -vcodec mjpeg -vframes 1 -an -f m4v -ss %time% %dst%").trigger("textchange");
				$("#preview_frames", configSetup).val("10").trigger("textchange");
				$("#preview_movie_info_command_line", configSetup).val("ffmpeg.exe -i %src%").trigger("textchange");
			}
			else
			{
				$("#preview_conversion_threads", configSetup).val("1").trigger("textchange");
				$("#preview_working_dir", configSetup).val("/usr/bin/").trigger("textchange");
				$("#preview_environment", configSetup).val("PATH=/opt/local/bin:/opt/local/sbin:/opt/local/bin:/opt/local/sbin:/usr/bin:/bin:/usr/sbin:/sbin:/usr/local/bin:/usr/local/git/bin:/usr/X11/bin").trigger("textchange");
				$("#preview_command_line", configSetup).val("ffmpeg.exe -i %src% -vcodec mjpeg -vframes 1 -an -f m4v -ss %time% %dst%").trigger("textchange");
				$("#preview_frames", configSetup).val("10").trigger("textchange");
				$("#preview_movie_info_command_line", configSetup).val("ffmpeg.exe -i %src%").trigger("textchange");
			}
			$("#preview_file_extensions", configSetup).val(".m4v, .mp4").trigger("textchange");
		}
		itemsChanged(true);
	});

	_panel.find("select").bind("change", function(){
		if($(this).hasClass("excludeXML"))return;
		updateStorageValue($(this).attr("id"), $(this).val())
		itemsChanged(true);
	});

	_panel.find("input[type='checkbox']").bind("change", function(){
		if($(this).hasClass("excludeXML"))return;
		updateStorageValue($(this).attr("id"), $(this).is(":checked"))
		itemsChanged(true);
	});

	_panel.find("input[type='text'], textarea").bind("textchange", function(){
		if($(this).hasClass("excludeXML"))return;
		updateStorageValue($(this).attr("id"), $(this).val())
		itemsChanged(true);
	});
}

panelPreview.bindSizeDetails = function(selected)
{
	if(!selected)return;
	var size = selected.data("controlData");
	size = size.text.split("x");
	if(size.length>0)
	{
		$("#preview_max_width", _panel).val(size[0]);
		$("#preview_max_height", _panel).val(size[1]);
	}
}

panelPreview.saveContent = function()
{
	if(placeHolder.data("hasChanged"))
	{
		var subConfigs = panelPreview.configs;
		var xml = [];
		xml.push("<preview_configs type=\"vector\">");
		if(subConfigs && subConfigs.length>0)
		{
			for(var i=0;i<subConfigs.length;i++)
			{
				xml.push("<preview_configs_subitem type=\"properties\">");
				var curConfig = subConfigs[i];
				for(var item in curConfig)
				{
					if(item != "type")
					{
						if(item == "preview_folder_list")
						{
							xml.push("<preview_folder_list type=\"vector\">");
							var curList = curConfig[item][0].preview_folder_list_subitem;
							if(curList)
							{
								for(var j=0;j<curList.length;j++)
								{
									if(curList[j].text)
										xml.push("<preview_folder_list_subitem>" + curList[j].text + "</preview_folder_list_subitem>");
								}
							}
							xml.push("</preview_folder_list>");
						}
						else if(item == "preview_sizes")
						{
							xml.push("<preview_sizes type=\"vector\">");
							var curList = curConfig[item][0].preview_sizes_subitem;
							if(curList)
							{
								for(var j=0;j<curList.length;j++)
								{
									if(curList[j].text)
										xml.push("<preview_sizes_subitem>" + curList[j].text + "</preview_sizes_subitem>");
								}
							}
							xml.push("</preview_sizes>");
						}
						else
						{
							if(curConfig[item] && curConfig[item].length>0)
							{
								var text = curConfig[item][0].text || "";
								if(item == "preview_conversion_threads" && text == "")
									text = 1;
								xml.push("<"+item+">" + common.methods.htmlEncode(text) + "</"+item+">");
							}
						}
					}
				}
				xml.push("</preview_configs_subitem>");
			}
		}
		xml.push("</preview_configs>");
		var xmlData = '<server_prefs type="properties">'+xml.join("\r\n")+'</server_prefs>';
		common.UI.showIndicator(false, false, "Please wait..");
		common.data.setXMLPrefs("server_settings/server_prefs/", "properties", "update", xmlData, function(data){
			data = $.xml2json(data, true);
			if(data.response_status && getTextValueFromXMLNode(data.response_status) && getTextValueFromXMLNode(data.response_status) == "OK")
			{
				common.data.updateLocalPrefs(function(){
					common.UI.hideIndicator();
					growl("Data saved", "Your changes are saved", false, 5000);
					placeHolder.removeData("hasChanged");
				});
			}
			else
			{
				common.UI.hideIndicator();
				growl("Error while saving", "Your changes are not saved", true);
			}
		});
	}
	else
	{
		growl("No changes made", "", false, 3000);
	}
}

panelPreview.buildXMLData = function()
{
	var xmlString = buildXMLToSubmitForm(_panel);
	return xmlString;
}