/****************************
CrushFTP GUI Panel custom js
*****************************/
/* Do not change these lines */
var panelMisc = {};
panelMisc.localization = {};
/****************************/

// Panel details
var panelName = "Misc";
panelMisc._panel = $("#pnl" + panelName);

// Localizations
panelMisc.localization = {
};

// Assign localizations
localizations.panels[panelName] = $.extend(panelMisc.localization, localizations.panels[panelName]);

// Interface methods
panelMisc.init = function(){
	applyLocalizations(panelName, localizations.panels);
	window.dataBindEvents.push(panelMisc.bindData);
	panelMisc.bindEvents();
}

panelMisc.clearForm = function(panel)
{
	panel = panel || panelTunnels._panel;
	panel.find("input, select, textarea").each(function(){
		if($(this).attr("type")=="checkbox")
		{
			if($(this).closest("td").is(".checkboxArea"))return;
			userManager.UI.checkUnchekInput($(this));
		}
		else
		{
			$(this).val("");
		}
	});
}

panelMisc.bindData = function(userInfo, jsonDeep, panel)
{
	var dataPanel = panel || panelMisc._panel;
	panelMisc.clearForm(dataPanel);

	if(panel)
	{
		panel.removeClass("inheritValSet");
	}
	if(userInfo.user)
	{
		userManager.data.bindValuesFromJson(dataPanel, userInfo.user, false, panel);
		//Bind extra text references
		var extraTextReference = $("#extraTextReference", dataPanel).empty();
		var currentUserData = userManager.storage("currentUser").user;
		for(var item in currentUserData)
		{
			if(item.toString().indexOf("x_")==0)
			{
				extraTextReference.append("<li class='ui-widget-content' key='"+item.replace("x_" , "")+"' _value='"+currentUserData[item]+"'>"+ userManager.methods.htmlEncode(item) + " : " + userManager.methods.htmlEncode(currentUserData[item]) +"</li>");
			}
		}
	}
	userManager.UI.panelsPostbindEvent(dataPanel, panel);
}

panelMisc.bindEvents = function()
{
	//Toggle sections for this panel
	userManager.UI.togglePanels(panelMisc._panel);
	$(".checkboxArea>input[type='checkbox']", panelMisc._panel).change(function(){
		var curUserData = userManager.storage("currentUserInherited");
		if(!$(this).is(":checked"))
		{
			curUserData = {user: userManager.storage("currentUsersLowerLevelsData")};
			$(this).closest("fieldset").addClass("inheritSet");
		}
		else
			$(this).closest("fieldset").removeClass("inheritSet");
		if(!$(this).closest("fieldset").hasClass("notInheritable"))
			panelMisc.bindData(curUserData, false, $(this).closest("fieldset"));
	});

	// Setup POSIX
	$("#setupPOSIX", panelMisc._panel).unbind("click").click(function(){
		//User name entry
		function enterOwner(callback)
		{
			var input = $("#default_owner_command", panelMisc._panel);
			var owner = $.trim(input.val());
			if(owner.length == 0) owner = "www";
			jPrompt("Enter OS X user name : ", owner, "Default 'user' to set owner to : ", function(value){
				if(value != null)
				{
					input.val($.trim(value));
					if(callback)
						callback();
				}
			});
		}

		//Group name entry
		function enterGroup(callback)
		{
			var input = $("#default_group_command", panelMisc._panel);
			var group = $.trim(input.val());
			if(group.length == 0) group = "staff";
			jPrompt("Enter OS X group name : ", group, "Default 'group' to set group to : ", function(value){
				if(value != null)
				{
					input.val($.trim(value));
					if(callback)
						callback();
				}
			});
		}

		//Permissions entry
		function enterPermissions(callback)
		{
			var input = $("#default_privs_command, #default_folder_privs_command", panelMisc._panel);
			var perm = $.trim(input.val());
			if(perm.length == 0) perm = "777";
			jPrompt("Enter OS X group name : ", perm, "Default permissions to set file to : ", function(value){
				if(value != null)
				{
					input.val($.trim(value));
					if(callback)
						callback();
				}
			});
		}

		enterOwner(function(){
			panelMisc._panel.trigger("changed");
			enterGroup(function(){
				enterPermissions();
			});
		});
		return false;
	});

	// Add file name filter
	$("a#addFileFilter", panelMisc._panel).click(function(){
		jPrompt("Choose One : ", "", "Stop Options", function(value){
			if(value != null)
			{
				var filterType = value;
				jPrompt("Please enter the text : ", "", "CrustFTP Filters", function(value){
					if(value != null)
					{
						var file_filter = $("textarea#file_filter", panelMisc._panel);
						file_filter.val(file_filter.val() + ":" + filterType + ":" + value  +";\n");
						panelMisc._panel.trigger("changed");
					}
				});
			}
		}, ["LS|(Listing) Starts With",
			"LC|(Listing) Contains",
			"LE|(Listing) Ends With",
			"RS|(Rename) Starts With",
			"RC|(Rename) Contains",
			"RE|(Rename) Ends With",
			"US|(Upload) Starts With",
			"UC|(Upload) Contains",
			"UE|(Upload) Ends With",
			"DS|(Download) Starts With",
			"DC|(Download) Contains",
			"DE|(Download) Ends With"]);
		return false;
	});

	//Extra text reference events
	var extraTextReference = $("#extraTextReference", panelMisc._panel);

	//Event to add extra text ref
	$("a#addTextRef", panelMisc._panel).click(function(evt, control){
		var key =  "";
		var val = "";
		if(control && control.length>0 && control.attr("key"))
		{
			key = control.attr("key");
			val = control.attr("_value");
		}
		jPrompt("Please enter the variable name : ", key, "Variable Name", function(value){
			key = value;
			if(key != null)
			{
				key = userManager.methods.htmlEncode(key);
				jPrompt("Please enter the variable value :", val, "Variable Value", function(value){
					val = value;
					if(val != null)
					{
						if(control) // If edit mode
						{
							userManager.UI.addItem(extraTextReference
								, $("<li class='ui-widget-content' key='"+key+"' _value='"+val+"'>x_"+ key + " : " + userManager.methods.htmlEncode(val) +"</li>")
								, false, function(newControl){
								control.replaceWith(newControl); // Append to list and replace selected with new item
							});
						}
						else // If add mode
						{
							userManager.UI.addItem(extraTextReference
								, $("<li class='ui-widget-content' key='"+key+"' _value='"+val+"'>x_"+ key + " : " + userManager.methods.htmlEncode(val) +"</li>"));
						}
						panelMisc._panel.trigger("changed");
					}
				});
			}
		});
		return false;
	});

	//Event to edit extra text ref
	$("a#editTextRef", panelMisc._panel).click(function(){
		var selected = extraTextReference.find("li.ui-selected");
		if(selected && selected.length > 0)
		{
			$("a#addTextRef", panelMisc._panel).trigger("click", [selected]);
		}
		return false;
	});

	//Event to remove extra text ref
	$("a#removeTextRef", panelMisc._panel).click(function(){
		var selected = extraTextReference.find("li.ui-selected");
		if(selected && selected.length > 0)
		{
			userManager.UI.removeItem(extraTextReference);
			panelMisc._panel.trigger("changed");
		}
		return false;
	});
}

panelMisc.generateXML = function()
{
	var xml = "";

	//General items
	panelMisc._panel.find("td.checkboxArea").not(".specialProperty").find("input:checked").each(function(){
		var formPanel = $(this).closest("td").next();
		xml += "\r\n" + userManager.data.buildXMLToSubmitForm(formPanel);
	});

	if(panelMisc._panel.find("#extraTextReferencesCheck").find("input:checked").length>0)
	{
		$("#extraTextReference", panelMisc._panel).find("li").each(function(){
			xml += "\r\n<x_" + $(this).attr("key") + ">" + userManager.methods.htmlEncode($(this).attr("_value")) + "</x_" + $(this).attr("key") + ">";
		});
	}

	return xml;
}